%define ocamlname cohttp-lwt-unix

Name:           ocaml-%{ocamlname}
Version:        1.0.2
Release:        1%{?dist}.emp1
Summary:        lwt_unix bindings for cohttp
License:        ISC
URL:            https://github.com/mirage/ocaml-%{ocaml-name}
Source0:        cohttp-%{version}.tbz

Requires:  	ocaml >= 4.03.0
Requires:	ocaml-conduit-lwt-unix >= 1.0.3
Requires:	ocaml-cmdliner
Requires:	ocaml-magic-mime
Requires:	ocaml-logs
Requires:	ocaml-fmt >= 0.8.2
Requires:	ocaml-cohttp-lwt >= 1.0.2
Requires:	ocaml-lwt >= 3.0.0
Requires:	ocaml-lwt < 4.0.0

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.03.0
BuildRequires:  jbuilder
BuildRequires:  ocaml-ounit
BuildRequires:	ocaml-conduit-lwt-unix-devel >= 1.0.3
BuildRequires:	ocaml-cmdliner-devel
BuildRequires:	ocaml-magic-mime-devel
BuildRequires:	ocaml-logs-devel
BuildRequires:	ocaml-fmt-devel >= 0.8.2
BuildRequires:	ocaml-cohttp-lwt-devel >= 1.0.2
BuildRequires:	ocaml-lwt-devel >= 3.0.0
BuildRequires:	ocaml-lwt-devel < 4.0.0

Conflicts:	lwt < 2.5.0

%description
Cohttp is an OCaml library for creating HTTP daemons. It has a portable
HTTP parser, and implementations using various asynchronous programming
libraries:

* `Cohttp_lwt_unix` uses the [Lwt](https://ocsigen.org/lwt/) library, and
  specifically the UNIX bindings.
* `Cohttp_async` uses the [Async](https://realworldocaml.org/v1/en/html/concurrent-programming-with-async.html)
  library.
* `Cohttp_lwt` exposes an OS-independent Lwt interface, which is used
  by the [Mirage](https://mirage.io/) interface to generate standalone
  microkernels (use the cohttp-mirage subpackage).
* `Cohttp_lwt_xhr` compiles to a JavaScript module that maps the Cohttp
  calls to XMLHTTPRequests.  This is used to compile OCaml libraries like
  the GitHub bindings to JavaScript and still run efficiently.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-conduit-lwt-unix-devel >= 1.0.3
Requires:	ocaml-cmdliner-devel
Requires:	ocaml-magic-mime-devel
Requires:	ocaml-logs-devel
Requires:	ocaml-fmt-devel >= 0.8.2
Requires:	ocaml-cohttp-lwt-devel >= 1.0.2
Requires:	ocaml-lwt-devel >= 3.0.0
Requires:	ocaml-lwt-devel < 4.0.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n cohttp-%{version}

%build
jbuilder subst -n %{ocamlname}
jbuilder build -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}/%{_libdir}/ocaml/bin/* %{buildroot}/%{_bindir}/.

#%check
#jbuilder runtest  -p %{ocamlname} %{?_smp_mflags}

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%{_bindir}/*
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
